/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package bank;


import java.sql.*;
import javax.jws.WebMethod;
import javax.jws.WebParam;
import javax.jws.WebService;
import javax.ejb.Stateless;

/**
 *
 * @author prashanth
 */
@WebService()
@Stateless()
public class MoneyTransferWebService 
{

    Connection conn = null;
   
    /**
     * Web service operation
     */
    @WebMethod(operationName = "Transfer")
    public String Transfer(@WebParam(name = "fromAcc")
    String fromAcc, @WebParam(name = "toAcc")
    String toAcc, @WebParam(name = "authKey")
    String authKey, @WebParam(name = "amount")
    double amount) {
        
        //System.out.println(fromAcc);
        String result;
        
        try
        {
            connect();
                      
            result = doTransaction(fromAcc, toAcc, authKey, amount);
            
            conn.close();
        }
        catch(Exception e)
        {
            result="APPLICATION ERROR";
        }
        return result;
    }
    
    private String doTransaction(String fromAcc, String toAcc, String authKey, double amount)
    {
        double balance=0;
        try
        {
            Statement st=conn.createStatement();
            
            //Get balance of fromAcc
            st.execute("SELECT balance FROM bank.Accounts WHERE acc_no = '" + fromAcc +"'");            
            ResultSet rs=st.getResultSet();            
            
            if(rs.next())
            {
                balance=rs.getDouble("balance");
                System.out.println("Balance="+balance);        
            }
            else
            {
                return "ERROR: Account does not exist";
            }    
            
            //Check whether toAcc is authorized
            st.execute("SELECT * FROM bank.Authorizations WHERE byAcc = '" + fromAcc+ "' AND authKey='" + authKey +"'" );
            rs=st.getResultSet();
                      
            if(rs.next())
            {
                String to = rs.getString("fromAcc");
                
                if(toAcc.equals(to))
                {
                    if(balance<amount)
                        return "ERROR: Not enough money in account " + fromAcc;
                    else
                    {
                        //money transfer
                        try
                        {
                            st.executeUpdate("UPDATE bank.Accounts SET balance=balance-"+amount+" WHERE acc_no='"+fromAcc+"'");
                            st.executeUpdate("UPDATE bank.Accounts SET balance=balance+"+amount+" WHERE acc_no='"+toAcc+"'");
                            return "success";
                        }
                        catch(SQLException ex)
                        {
                            System.out.println(ex);
                            return "ERROR: Money transfer failed!";
                        }
                        
                    }
                }
                else
                {
                    return "ERROR: Not Authorized";
                }
            }
            else
            {
                return "ERROR: Not Authorized";
            }          
            
        }
        catch(SQLException ex)
        {
            return "APPLICATION ERROR"+ex;
        }        
    }
    
    public void connect() throws Exception
    {
        String driver = "org.apache.derby.jdbc.ClientDriver";
        String dbName="/BankDatabase;";
        String auth = "user=bank;password=bank";
        String connectionURL = "jdbc:derby://localhost:1527" + dbName + auth;  
        

        try
        {
            Class.forName(driver); 
        }
        catch(java.lang.ClassNotFoundException e) 
        {
            e.printStackTrace();
        }

        try 
        {
            conn = DriverManager.getConnection(connectionURL); 
            System.out.println("Connected");
            //body of code to go here

        }
        catch (Throwable e)  
        {   
            e.printStackTrace();
        }
        
    }

}
